//+------------------------------------------------------------------+
//|                                             feat  DailyRange.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property  indicator_maximum  1.23000000
#property  indicator_minimum  1.0200080

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_plots 5
#property indicator_type1 DRAW_LINE
#property indicator_color1 clrWhite
#property indicator_label1 "2020"
#property indicator_width1  4


#property indicator_type2 DRAW_LINE
#property indicator_color2 clrYellow
#property indicator_label2 "2019"
#property indicator_width2  3

#property indicator_type3 DRAW_LINE
#property indicator_color3 clrOrange
#property indicator_label3 "2018"
#property indicator_width3  2

#property indicator_type4 DRAW_LINE
#property indicator_color4 clrRed
#property indicator_label4 "2017"


#property indicator_type5 DRAW_LINE
#property indicator_color5 clrPurple
#property indicator_label5 "2016"


#property indicator_type6 DRAW_LINE
#property indicator_color6 clrMagenta
#property indicator_label6 "t"
#property indicator_style6 STYLE_DASH




double c20[],c19[];
double c18[],c17[];
double c16[],c15[];





//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,c20,INDICATOR_DATA);
   SetIndexBuffer(1,c19,INDICATOR_DATA);
    SetIndexBuffer(2,c18,INDICATOR_DATA);
    SetIndexBuffer(3,c17,INDICATOR_DATA);
    SetIndexBuffer(4,c16,INDICATOR_DATA);
    SetIndexBuffer(5,c15,INDICATOR_DATA);
   
   
   
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN ,4700);
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN ,4700);
    PlotIndexSetInteger(2,PLOT_DRAW_BEGIN ,4700);
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN ,4700);
    PlotIndexSetInteger(4,PLOT_DRAW_BEGIN ,4700);
  
    PlotIndexSetInteger(5,PLOT_DRAW_BEGIN ,4700);
  
   
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //-- house keeping 
   int limit,copied;
   datetime start=D'2015.1.1';
   if(prev_calculated==0)
      limit=0;
   else limit=prev_calculated-1;
   
   //--copy data
   datetime dayTime[];
   double dayc2020[],dayc2019[];
    double dayc2018[],dayc2017[];
    double dayc2016[],dayc2015[];
   
   copied=CopyTime(_Symbol,PERIOD_D1,start,time[rates_total-1],dayTime);
   if(copied<=0) return -1;
   copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2020);
   if(copied<=0) return -1;
   copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2019);
   if(copied<=0) return -1;
   
    copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2018);
   if(copied<=0) return -1;
   copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2017);
   if(copied<=0) return -1;
   
    copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2016);
   if(copied<=0) return -1;
   copied=CopyClose(_Symbol,PERIOD_D1,start,time[rates_total-1],dayc2015);
   if(copied<=0) return -1;
   
   

   //-- calculate indicators
   MqlDateTime mdtDay,mdt;
   for(int i=limit; i<rates_total; i++)
     {
      TimeToStruct(time[i],mdt);
      for(int j=0; j<copied; j++)
        {
         TimeToStruct(dayTime[j],mdtDay);
         if(mdtDay.day == mdt.day && mdtDay.mon == mdt.mon && mdtDay.year == mdt.year)
           {
           if(j>1000)
            c20[i] = dayc2020[j];
            if(j>1000)
            c19[i] = dayc2019[j-261];
            
            if(j>1000)
            c18[i] = dayc2018[j-520];
            if(j>1000)
            c17[i] = dayc2017[j-780];
            
            if(j>1100)
            c16[i] = dayc2016[j-1039];
            if(j>2000)
            c15[i] =  (dayc2020[j]+dayc2019[j-260]+dayc2018[j-520]+dayc2017[j-780]+dayc2016[j-1000])/5;
            
            
            
            
            
           }
        }
     }
     
       MqlDateTime tm,tm2020;
       
       
  //  year_ago_bar_s=261    520   780     1039 expart tub
    
    for(int i=0; i<Bars(_Symbol,PERIOD_CURRENT)-1; i++)   
  { 
  MqlDateTime tm,tm2020;
      MqlDateTime tm2018;
   TimeToStruct(time[i],tm);
   TimeToStruct(time[i+1],tm2020);
   // TimeToStruct(time[i+1],tm2018);
 
     int year=tm.year;
     int year2020=tm2020.year;
     //   int year2018=tm2018.year;
  // if(year2019=year2018) 
   if(year2020==year) 
    continue;
    
    Print("year2020=",year2020);
    
  int   year_ago_bar=i+1;//???
    Print("year_ago_bar=",year_ago_bar);
    
  int year_ago_bar_s = iBarShift(Symbol(),Period(),time[i]-PeriodSeconds()*365,false);
  Print("year_ago_bar_s=",year_ago_bar_s);
 // Print("time[i]=",time[i]);
  
     
     
  }   
     
   return(rates_total);
  }
//+------------------------------------------------------------------+
